import { ComputeBooleanNode } from '@compute.ts/boolean';
import { ComputeApiNode } from '@compute.ts/core';
import { ComputeDateNode } from '@compute.ts/date';
import { ComputeNumberNode } from '@compute.ts/number';
import { ComputeStringNode } from '@compute.ts/string';
export declare class ComputeArrayNode<NodeType extends ComputeApiNode<RawType>, RawType> extends ComputeApiNode<RawType[]> {
    private nodifier;
    private expression;
    private static fingerprint;
    private fingerprint;
    static expression<NodeType extends ComputeApiNode<RawType>, RawType>(children: ComputeApiNode<any>[], evalFn: (...args: any[]) => RawType[], nodifier: (x: NodeType | RawType) => NodeType, expression: (args: ComputeApiNode<any>[], fn: (...args: any[]) => RawType) => NodeType): ComputeArrayNode<NodeType, RawType>;
    static expressionBoolean(children: ComputeApiNode<any>[], evalFn: (...args: any[]) => boolean[]): ComputeArrayNode<ComputeBooleanNode, boolean>;
    static expressionNumber(children: ComputeApiNode<any>[], evalFn: (...args: any[]) => number[]): ComputeArrayNode<ComputeNumberNode, number>;
    static expressionString(children: ComputeApiNode<any>[], evalFn: (...args: any[]) => string[]): ComputeArrayNode<ComputeStringNode, string>;
    static expressionDate(children: ComputeApiNode<any>[], evalFn: (...args: any[]) => Date[]): ComputeArrayNode<ComputeDateNode, Date>;
    static nodify<NodeType extends ComputeApiNode<RawType>, RawType>(input: ComputeArrayNode<NodeType, RawType> | (NodeType | RawType)[], nodifier: (x: NodeType | RawType) => NodeType, expression: (args: NodeType[], fn: (...args: any[]) => RawType) => NodeType): ComputeArrayNode<NodeType, RawType>;
    static nodifyBoolean(input: ComputeArrayNode<ComputeBooleanNode, boolean> | (ComputeBooleanNode | boolean)[]): ComputeArrayNode<ComputeBooleanNode, boolean>;
    static nodifyNumber(input: ComputeArrayNode<ComputeNumberNode, number> | (ComputeNumberNode | number)[]): ComputeArrayNode<ComputeNumberNode, number>;
    static nodifyString(input: ComputeArrayNode<ComputeStringNode, string> | (ComputeStringNode | string)[]): ComputeArrayNode<ComputeStringNode, string>;
    static nodifyDate(input: ComputeArrayNode<ComputeDateNode, Date> | (ComputeDateNode | Date)[]): ComputeArrayNode<ComputeDateNode, Date>;
    constructor(children: ComputeApiNode<any>[], evalFn: (...args: any[]) => RawType[], nodifier: (args: NodeType | RawType) => NodeType, expression: (args: ComputeApiNode<any>[], fn: (...args: any[]) => RawType) => NodeType);
    leftTail(): ComputeArrayNode<NodeType, RawType>;
    rightTail(): ComputeArrayNode<NodeType, RawType>;
    leftHead(): ComputeArrayNode<NodeType, RawType>;
    rightHead(): ComputeArrayNode<NodeType, RawType>;
    concatRight(...elements: (NodeType | RawType)[]): ComputeArrayNode<NodeType, RawType>;
    concatLeft(...elements: (NodeType | RawType)[]): ComputeArrayNode<NodeType, RawType>;
    isEmpty(): ComputeBooleanNode;
    reverse(): ComputeArrayNode<NodeType, any>;
    size(): ComputeNumberNode;
    subArray(start: ComputeNumberNode | number, end: ComputeNumberNode | number): ComputeArrayNode<NodeType, any>;
    shuffle(): ComputeArrayNode<NodeType, any>;
    access(index: ComputeNumberNode | number): NodeType;
    accessFirst(): NodeType;
    accessLast(): NodeType;
    firstIndexOf(element: NodeType | RawType): ComputeNumberNode;
    indexesOf(element: NodeType | RawType): ComputeArrayNode<ComputeNumberNode, number>;
    lastIndexOf(element: NodeType | RawType): ComputeNumberNode;
    includes(element: NodeType | RawType): ComputeBooleanNode;
}
